;### callbacks from player

;The sub_callback is just an example. You need to modify it to suit your needs. Basically the callbacks are just there so you can use different memory management or loading methods. If you find the call for those in the nmp.asm maybe that will make stuff more clear. I can also write up a wrapper that just loads and plays a file.

;The modplayer (com file) uses "normal" calls to DOS, I'm working on another project that does that very differently.

;mt_memoryInit: Initialize the mapper if you need to do that. Otherwise just "RET"
;mt_memorySet: Passes the pattern data address in carryflag+DE. You need to remap that to some other location and set the mapper. I am using the higest 2 bytes of DE and the carry flag (so max 128KB) and select the corresponding memory mapper page. After that I set bit 7 and reset bit 6 of D so it gets remapped to #8000-#BFFF.
;mt_loadData: Loads data somewhere that is not persistent (sample data is moved to SRAM). You will be needing the mod header until loading is finished. I use #4000-#7FFF and set the q_samploadbuffersize to #2000 so it will split up the loading of sampes in 8KB blocks. Note that if your are loading from a file, it needs to be opened first.
;mt_loadPattern: Loads data that is persistent (pattern data only). When entering carry flag and DE specifies the MOD pattern address.
;mt_progressLoadSample: You put in RET. It is used if you want to do some progress display on the load process. The COM player uses it to dispay the number of samples loaded on screen.

;If you need some help and I am not responding of the thread, just send me an email. 

;p_modheader	equ #4000
p_samplebuffer	equ #6000
q_samploadbuffersize	equ #2000

mt_memoryInit
;Initialize memory manager
;In:
; -
;Out:
; -
;Changes:
; Everything
	;ld (mt_OAT_Pointer),hl
	push	af
	push	hl
	ld	a,(v_PAGMEM)
	ld	(mt_PAGMEM_MOD),a
	ld	hl,(v_ADRMEM)
	ld	(mt_ADRMEM_MOD),hl
	pop	hl
	pop	af
	ret

mt_memorySet
;Select memory. DE is changed to the new location
;In:
; DE=offset
;Out:
; DE=memory location
;Changes:
; Everything
	call	f_selectPages
	ret

mt_loadData:	PROC
;Get bytes for MOD (Header/Samples)
;This data is only needed when loading the file
;In:
; HL=bytes to load (not used)
; DE=destination address (cannot be in the 8000-BFFF range)
; p_modheader (1084 bytes)
; p_samplebuffer (q_samploadbuffersize bytes)
;Out:
; -
;Changes:
; Everything
	ld	a,(v_fileHandleMOD)
	ld	b,a
	ld	c,#48	;_READ
	call	bdos
	or	a
	call	nz,f_explainError
	jp	nz,f_doTermWithError
	ret
	ENDP

mt_loadPattern:	PROC
;Get data for MOD (Pattern)
;Needs to be available
;In:
; HL=bytes to load
; CF,DE=destination address (offset 0)
;Out:
; -
;Changes:
; Everything
	call	mt_memorySet

	push	bc
	push	de
	push	hl
	ld	de,d_msgPatternLoad
	call	f_printString
	pop	hl
	pop	de
	pop	bc

	ld	a,(v_mmuMax)
	dec	a
	cp	c
	jr	c,outofmemory

	ld	a,(v_fileHandleMOD)
	ld	b,a
	ld	c,#48	;_READ
	call	bdos
	or	a
	call	nz,f_explainError
	jp	nz,f_doTermWithError
	ret
outofmemory:
	ld	hl,d_Error_OutOfMemory
	jp	f_doTermWithError
	ENDP

mt_progressLoadSample:	PROC
;Used to display loading information (sample)
;In:
; IX=sample attributes in mod file
	push	bc
	push	de
	push	hl
	ld	de,d_msgSampleLoad
	call	f_printString
	pop	hl
	pop	de
	pop	bc
	ret
	ENDP

mt_command8:	PROC
;Used to send a value to the implementing program
;In:
; IX=position in the pattern data (IX+3) contains the parameter value
	ret
	ENDP
